/*******************************************************************************
 * FreeAdhocUDF - copyright (c) 2004 - 2009 adhoc dataservice GmbH
 * Christoph Theuring ct / Peter Mandrella pm / Georg Horn gh
 * <http://freeadhocudf.org> eMail <help@freeadhocudf.org>
 * (bug-)reports only in forum http://freeadhocudf.org/portal 
 * or eMail to help@freeadhocudf.org
 *   
 * this file contains declarations of all new functions from FreeAdhocUDF
 * from version adhoc20090925
 * use from FireBird 2.0 - possibility to return NULL
 *  
 * if you use this declarations in a non UTF-8 or UNICODE_FSS database 
 *		the max lenght of CSTRING is 32766 (1 Byte per character)
 * if you use this declarations in a InterBase UNICODE_FSS database 
 *		the max lenght of CSTRING is 10922 (3 Byts per character)
 * if you use this declarations in a InterBase or FireBird UTF-8 database 
 *		the max lenght of CSTRING is 8191 (max 4 Byts per character)
 * All declarations in this file are set to CSTRING(8191)
 * if you want to use one UDF more times in one piped string or one SQL, 
 * the sum of CSTRING of the used UDF doesn't grow over the max of your database
 *
 * Functions in group and alphabetical order
 *
 * This file is part of FreeAdhocUDF.
 * FreeAdhocUDF is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * FreeAdhocUDF is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with FreeAdhocUDF.  If not, see <http://www.gnu.org/licenses/>. 
*******************************************************************************/

SET SQL DIALECT 3;

/******************************************************************************/
/****                User Defined Functions - Math Functions               ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_INPUTVAL
    DOUBLE PRECISION ,
    CSTRING(10) 
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'inputval' MODULE_NAME 'FreeAdhocUDF';
 
/******************************************************************************/
/****                 User Defined Functions: Date and Time                ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_FIRSTDAYLASTWEEK
   TIMESTAMP 
   RETURNS TIMESTAMP FREE_IT
   ENTRY_POINT 'firstdaylastweek' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYLASTWEEK
   TIMESTAMP 
   RETURNS TIMESTAMP FREE_IT
   ENTRY_POINT 'lastdaylastweek' MODULE_NAME 'FreeAdhocUDF';
       
DECLARE EXTERNAL FUNCTION F_FIRSTDAYLASTWEEKISO
   TIMESTAMP 
   RETURNS TIMESTAMP FREE_IT
   ENTRY_POINT 'firstdaylastweekiso' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYLASTWEEKISO
   TIMESTAMP 
   RETURNS TIMESTAMP FREE_IT
   ENTRY_POINT 'lastdaylastweekiso' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIRSTDAYNEXTWEEK
   TIMESTAMP 
   RETURNS TIMESTAMP FREE_IT
   ENTRY_POINT 'firstdaynextweek' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYNEXTWEEK
   TIMESTAMP 
   RETURNS TIMESTAMP FREE_IT
   ENTRY_POINT 'lastdaynextweek' MODULE_NAME 'FreeAdhocUDF';
       
DECLARE EXTERNAL FUNCTION F_FIRSTDAYNEXTWEEKISO
   TIMESTAMP 
   RETURNS TIMESTAMP FREE_IT
   ENTRY_POINT 'firstdaynextweekiso' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYNEXTWEEKISO
   TIMESTAMP 
   RETURNS TIMESTAMP FREE_IT
   ENTRY_POINT 'lastdaynextweekiso' MODULE_NAME 'FreeAdhocUDF';
       
DECLARE EXTERNAL FUNCTION F_FIRSTDAYLASTMONTH
   TIMESTAMP 
   RETURNS TIMESTAMP FREE_IT
   ENTRY_POINT 'firstdaylastmonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYLASTMONTH
   TIMESTAMP 
   RETURNS TIMESTAMP FREE_IT
   ENTRY_POINT 'lastdaylastmonth' MODULE_NAME 'FreeAdhocUDF';
   
DECLARE EXTERNAL FUNCTION F_FIRSTDAYNEXTMONTH
   TIMESTAMP 
   RETURNS TIMESTAMP FREE_IT
   ENTRY_POINT 'firstdaynextmonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYNEXTMONTH
   TIMESTAMP 
   RETURNS TIMESTAMP FREE_IT
   ENTRY_POINT 'lastdaynextmonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIRSTDAYLASTQUARTER
   TIMESTAMP 
   RETURNS TIMESTAMP FREE_IT
   ENTRY_POINT 'firstdaylastquarter' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYLASTQUARTER
   TIMESTAMP 
   RETURNS TIMESTAMP FREE_IT
   ENTRY_POINT 'lastdaylastquarter' MODULE_NAME 'FreeAdhocUDF';
   
DECLARE EXTERNAL FUNCTION F_FIRSTDAYNEXTQUARTER
   TIMESTAMP 
   RETURNS TIMESTAMP FREE_IT
   ENTRY_POINT 'firstdaynextquarter' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYNEXTQUARTER
   TIMESTAMP 
   RETURNS TIMESTAMP FREE_IT
   ENTRY_POINT 'lastdaynextquarter' MODULE_NAME 'FreeAdhocUDF';

/******************************************************************************/
/****                User Defined Functions - BLOb Functions               ****/
/******************************************************************************/

/******************************************************************************/
/****                   User Defined Functions - other functions           ****/
/******************************************************************************/

/******************************************************************************/
/****                   User Defined Functions - UTF-8 functions           ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION U_CHR
    INTEGER 
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'u_character' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_CONVERTSYMBOLS
    CSTRING(8191) ,
    CSTRING(255) ,
    CSTRING(255) 
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_convertsymbols' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_CYRILLIC_LATIN
    CSTRING(8191) 
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_cyrillic_latin' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_FINDWORD
    CSTRING(8191) ,
    INTEGER 
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'u_findword' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_LEFT
    CSTRING(255) ,
    INTEGER 
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'u_left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_LEFT4
    CSTRING(4095) ,
    INTEGER 
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'u_left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_LEFT8
    CSTRING(8191) ,
    INTEGER 
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_LINEWRAP
    CSTRING(8191) ,
    INTEGER ,
    INTEGER 
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_linewrap' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_LOWER
    CSTRING(8191) 
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_lower' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_MID
    CSTRING(255) ,
    INTEGER ,
    INTEGER 
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'u_mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_MID4
    CSTRING(4095) ,
    INTEGER ,
    INTEGER 
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'u_mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_MID8
    CSTRING(8190) ,
    INTEGER ,
    INTEGER 
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_ORD
    CSTRING(1) 
    RETURNS SMALLINT FREE_IT
    ENTRY_POINT 'u_ord' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_PADCENTER
    CSTRING(4095) ,
    CSTRING(16) ,
    INTEGER 
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'u_padcenter' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_PADLEFT
    CSTRING(4095) ,
    CSTRING(16) ,
    INTEGER 
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'u_padleft' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_PADRIGHT
    CSTRING(4095) ,
    CSTRING(16) ,
    INTEGER 
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'u_padright' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_PRED
    CSTRING(1) ,
    INTEGER 
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'u_predecessor' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_PROPERCASE
    CSTRING(8191) 
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_propercase' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_REPEATTRIM
    CSTRING(8191) ,
    CSTRING(1) 
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_repeattrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_REPLACESTRING
    CSTRING(255) ,
    CSTRING(255) ,
    CSTRING(255) ,
    INTEGER ,
    INTEGER 
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'u_replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_REPLACESTRING4
    CSTRING(4095) ,
    CSTRING(255) ,
    CSTRING(255) ,
    INTEGER ,
    INTEGER 
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'u_replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_REPLACESTRING8
    CSTRING(8191) ,
    CSTRING(255) ,
    CSTRING(255) ,
    INTEGER ,
    INTEGER 
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_REVERSE
    CSTRING(255) 
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'u_reverse' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_REVERSE4
    CSTRING(4095) 
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'u_reverse' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_REVERSE8
    CSTRING(8191) 
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_reverse' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_RIGHT
    CSTRING(255) ,
    INTEGER 
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'u_right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_RIGHT4
    CSTRING(4095) ,
    INTEGER 
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'u_right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_RIGHT8
    CSTRING(8190) ,
    INTEGER 
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRCMP
    CSTRING(8191) ,
    CSTRING(8191) 
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'u_rstrcmp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRINGLENGTH
    CSTRING(255) 
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'u_stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRINGLENGTH4
    CSTRING(4095) 
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'u_stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRINGLENGTH8
    CSTRING(8191) 
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'u_stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRIPSTRING
    CSTRING(255) ,
    CSTRING(255) 
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'u_stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRIPSTRING4
    CSTRING(4095) ,
    CSTRING(255) 
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'u_stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRIPSTRING8
    CSTRING(8191) ,
    CSTRING(255) 
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRIPSTRINGHOLD
    CSTRING(255) ,
    CSTRING(255) 
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'u_stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRIPSTRINGHOLD4
    CSTRING(4095) ,
    CSTRING(255) 
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'u_stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRIPSTRINGHOLD8
    CSTRING(8191) ,
    CSTRING(255) 
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRRM
    CSTRING(8191) ,
    INTEGER 
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_strrm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRSTUFF
    CSTRING(8191) ,
    SMALLINT ,
    SMALLINT ,
    CSTRING(255) 
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_strstuff' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_SUBSTR
    CSTRING(255) ,
    CSTRING(255) 
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'u_substr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_SUBSTR4
    CSTRING(4095) ,
    CSTRING(255) 
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'u_substr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_SUBSTR8
    CSTRING(8091) ,
    CSTRING(255) 
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'u_substr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_SUCC
    CSTRING(1) ,
    INTEGER 
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'u_successor' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_UPPER
    CSTRING(8191) 
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_upper' MODULE_NAME 'FreeAdhocUDF';

/* adhoc 2009-09-25 */
