/*******************************************************************************
 * FreeAdhocUDF - copyright (c) 2004 - 2010 adhoc dataservice GmbH
 * Christoph Theuring ct / Peter Mandrella pm / Georg Horn gh
 * <http://freeadhocudf.org> eMail <help@freeadhocudf.org>
 *   
 * this file contains declarations of all new functions from FreeAdhocUDF
 * from version adhoc20101206
 * use from FireBird 2.0 - NO possibility to return NULL
 *  
 * if you use this declarations in a non UTF-8 or UNICODE_FSS database 
 *		the max lenght of CSTRING is 32766 (1 Byte per character)
 * if you use this declarations in a InterBase UNICODE_FSS database 
 *		the max lenght of CSTRING is 10922 (3 Byts per character)
 * if you use this declarations in a InterBase or FireBird UTF-8 database 
 *		the max lenght of CSTRING is 8191 (max 4 Byts per character)
 * All declarations in this file are set to CSTRING(8191)
 * if you want to use one UDF more times in one piped string or one SQL, 
 * the sum of CSTRING of the used UDF doesn't grow over the max of your database
 *
 * Functions in group and alphabetical order
 *
 * This file is part of FreeAdhocUDF.
 * FreeAdhocUDF is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * FreeAdhocUDF is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with FreeAdhocUDF.  If not, see <http://www.gnu.org/licenses/>. 
*******************************************************************************/

SET SQL DIALECT 3;

/******************************************************************************/
/****                User Defined Functions - String Functions             ****/
/******************************************************************************/


/******************************************************************************/
/****                User Defined Functions - Math Functions               ****/
/******************************************************************************/

 
/******************************************************************************/
/****                 User Defined Functions: Date and Time                ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_TZVALUETOUTC

    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'tzvalue_to_utc' MODULE_NAME 'FreeAdhocUDF';

/******************************************************************************/
/****                User Defined Functions - BLOb Functions               ****/
/******************************************************************************/

/******************************************************************************/
/****                   User Defined Functions - other functions           ****/
/******************************************************************************/

UPDATE RDB$DEPENDENCIES SET RDB$DEPENDED_ON_NAME = 'xyz' || RDB$DEPENDED_ON_NAME
WHERE RDB$DEPENDED_ON_TYPE = 15 AND RDB$DEPENDED_ON_NAME = 'F_VERSION';

DROP EXTERNAL FUNCTION F_VERSION;

DECLARE EXTERNAL FUNCTION F_VERSION
    RETURNS CSTRING(30) FREE_IT
    ENTRY_POINT 'version' MODULE_NAME 'FreeAdhocUDF';

UPDATE RDB$DEPENDENCIES
SET RDB$DEPENDED_ON_NAME = F_REPLACESTRING(RDB$DEPENDED_ON_NAME, 'xyz', '', 0, 0)
WHERE RDB$DEPENDED_ON_TYPE = 15 AND RDB$DEPENDED_ON_NAME STARTING WITH 'xyz';

DECLARE EXTERNAL FUNCTION F_VERSIONNAME
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'versionname' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_OSLANGUAGE
RETURNS CSTRING(2) FREE_IT
ENTRY_POINT 'oslanguage' MODULE_NAME 'FreeAdhocUDF';
    
/******************************************************************************/
/****                   User Defined Functions - UTF-8 functions           ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION U_NBSP
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'u_nbsp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_NNBSP
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'u_nnbsp' MODULE_NAME 'FreeAdhocUDF';    

DECLARE EXTERNAL FUNCTION U_DOWLONGLANG
    TIMESTAMP ,
    CSTRING(2) 
    RETURNS CSTRING(20) FREE_IT
    ENTRY_POINT 'u_dowlonglang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_DOWSHORTLANG
    TIMESTAMP ,
    CSTRING(2) 
    RETURNS CSTRING(5) FREE_IT
    ENTRY_POINT 'u_dowshortlang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_MONTHLONGLANG
    TIMESTAMP ,
    CSTRING(2) 
    RETURNS CSTRING(20) FREE_IT
    ENTRY_POINT 'u_monthlonglang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_MONTHSHORTLANG
    TIMESTAMP ,
    CSTRING(2) 
    RETURNS CSTRING(5) FREE_IT
    ENTRY_POINT 'u_monthshortlang' MODULE_NAME 'FreeAdhocUDF';  

/******************************************************************************/
/****              User Defined Functions - constant functions             ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_EPSILON
    RETURNS DOUBLE PRECISION BY VALUE
    ENTRY_POINT 'epsilon' MODULE_NAME 'FreeAdhocUDF';

/******************************************************************************/
/****              User Defined Functions - converting functions           ****/
/******************************************************************************/

/*
DROP EXTERNAL FUNCTION F_C_L100KM2MPGBGAL;
DROP EXTERNAL FUNCTION F_C_L100KM2MPUSGAL;
DROP EXTERNAL FUNCTION F_C_MPGBGAL2L100KM;
DROP EXTERNAL FUNCTION F_C_MPUSGAL2L100KM;
*/

DECLARE EXTERNAL FUNCTION F_C_L100KM2MPGBGAL
    DOUBLE PRECISION 
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'mpgbgal2lp100km' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L100KM2MPUSGAL
    DOUBLE PRECISION 
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'mpusgal2lp100km' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_MPGBGAL2L100KM
    DOUBLE PRECISION 
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'mpgbgal2lp100km' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_MPUSGAL2L100KM
    DOUBLE PRECISION 
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'mpusgal2lp100km' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_KMPL2L100KM
    DOUBLE PRECISION 
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'kmpl2lp100km' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L100KM2KMPL
    DOUBLE PRECISION 
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'lp100km2kmpl' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_MPL2L100KM
    DOUBLE PRECISION 
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'mpl2lp100km' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L100KM2MPL
    DOUBLE PRECISION 
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'lp100km2mpl' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LOCAL2UTC
    TIMESTAMP 
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'local2utc' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UTC2LOCAL
    TIMESTAMP 
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'utc2local' MODULE_NAME 'FreeAdhocUDF';

/* adhoc 2010-12-06 */
